#include<bits/stdc++.h>

using namespace std;


int main(){
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    int unos[n][m];
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> unos[i][j];
        }
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int doha[n][m];
        doha[0][0] = unos[0][0];
    	int blokada_i;
    	int blokada_j;
    	cin >> blokada_i >> blokada_j;
    	blokada_i--;
    	blokada_j--;
    	doha[blokada_i][blokada_j] = -1;
    	bool prvi = false;
        for(int i = 1; i < m; i++){
    	    if(doha[0][i] != -1){
    	        doha[0][i] = doha[0][i - 1] + unos[0][i];
    	    }
    	    else{
    	        prvi = true;
    	    }
        }
        for(int i = 1; i < n; i++){
            if(doha[i][0] != -1){
                doha[i][0] = unos[i][0];
		        doha[i][0] += doha[i - 1][0];
            }
    	    for(int j = 1; j < m; j++){
    		    if(doha[i - 1][j] == -1){
    		        doha[i][j] = unos[i][j] + doha[i][j - 1];
    		    }
    		    else if(doha[i][j - 1] == -1){
    		        doha[i][j] = unos[i][j] + doha[i - 1][j];
    		    }
    		    else if(doha[i - 1][j] < doha[i][j - 1]){
    			    doha[i][j] = unos[i][j] + doha[i - 1][j];
    		    }
    		    else
    		    {
    			    doha[i][j] = unos[i][j] + doha[i][j - 1];	
    		    }
    	    }
        }
        cout << doha[n - 1][m - 1] << '\n';
    }
}